***************************************************************************
*
*  APLICATIVO DE DEMONSTRACAO PARA CAONTROLE DE CATRACA
*  
*  revisao deste aplicativo 04/04/2006
*  Implementada a leitora de barras utilizada E=esquerda D=direita
*  
*  PROCEDIMENTO:
*  AGUARDA A ENTRADA DE QUALQUER NUMERO DE CARTAO E LIBERA A CATRACA.
*  
****************************************************************************
*  Estado das Saidas:
*  ------------------
*  SAI(11,.T.) Habilita giro sentido horario da catraca
*  SAI(12,.F.) Liga lampada vermelha
*  SAI(12,.T.) Liga Lampada verde
*  SAI(13,.T.) Habilita giro sentido anti-horario da catraca
*  SAI(14,.T.) Trava catraca incondicionalmente
*  As saidas 12, 13 e 14 so' podem ser setadas para T individualmente.
*  Caso mais de um seja setada, a prioridade e' a seguinte: 14 , 12 e 13.
*
*  Estado das Entradas:
*  --------------------
*  ENT(21) T somente ao final do giro, no sentido anti-horario, permanecendo
*            neste estado ate' que SAI(13,.F.) 
*  ENT(22) T somente ao final do giro, no sentido anti-horario 
*            neste estado ate' que SAI(12,.F.) 
*  ENT(23) T sempre que a catraca estiver em situacao de repouso
*  ENT(24) T indica catraca girando no sentido habilitado, volta a F ao final
*            do giro
****************************************************************************
SET SERIAL TO CATRACA
i=0
T = .T.
E01=.F.
E02=.F.
tempo=0
SAI(11,.F.)
SAI(12,.F.)
SAI(13,.F.)
SAI(14,.F.)
sentido1=" "
do while t=.t.
	SAI(12,.f.)	
	SAI(11,.f.)
	SAI(13,.f.)
	ATUSAI()
	cartao=space(15)
	set cursor on
	@ 1,1 say "PASSE O CARTAO: "
	@ 2,1 say ">               "
	@ 2,2 get cartao
	@ 2,2 say cartao
	* busca ultimo caracter para definir o sentido de liberacao
	i=LEN(cartao)
	sentido1=SUBSTR(cartao,i,1)
	DO WHILE T=.T.
	        E01=ENT(23)
		IF E01=.F.
			@ 1,1 say "POR FAVOR !!!! "
			@ 2,1 say "LIBERE CATRACA "
		ELSE
			EXIT
		ENDIF
	ENDDO
	*
	* chama rotina que testa validade do cartao no banco de dados da apli-
	* cacao.
	*
	@ 1,1 say "ACESSO LIBERADO "
	IF sentido1="D"
		@ 2,1 SAY " P/ ENTRADA  ..."
		* libera sentido horario (direito)
		SAI(11,.T.)

	ELSE
		@ 2,1 SAY " P/ SAIDA    ..."
		* libera sentido anti-horario (esquerdo)
		SAI(13,.T.)
	ENDIF
	SAI(12,.T.)
	ATUSAI()
	girou=.f.
	FOR tempo=1 to 200
	        E02=ENT(22)
		IF E02=.t.
			girou=.t.
			* trava imediatamente a catraca
			SAI(12,.f.)
			SAI(11,.f.)
			SAI(13,.f.)
			EXIT

		ENDIF
	NEXT
	IF girou=.f.
		* chama rotina que registra acesso no banco de dados
		loop
	ENDIF
ENDDO
QUIT
